//для датчика температуры
#include <OneWire.h>;
#define ONE_WIRE_BUS 12;             // номер пина на котором будет датчик температуры

OneWire oneWire(12);                 // включает интерфес на ножке
OneWire ds(12);

// для ЖК дисплея
#include <LiquidCrystal.h>;
LiquidCrystal lcd(8, 9, 4, 5, 6, 7 ); //стандартный дисплей ардуино

//для работы с флеш-памятью
#include <EEPROM.h>

// привызывает к названиям кнопок цифры
int button;
const int BUTTON_NONE   = 0;
const int BUTTON_RIGHT  = 1;
const int BUTTON_UP     = 2;
const int BUTTON_DOWN   = 3;
const int BUTTON_LEFT   = 4;
const int BUTTON_SELECT = 5;


byte data[9]; //массив для чтения датчиков температуры
byte i;

long temperatyra_kuba; //температура куба
int temperatyra_kuba_pred; //предыдущая температура куба для вычисления скорости нагрева
long temperatyra_deflegmatora; //температура дефлегматора
int temperatyra_deflegmatora_stab = 0; //температура стабилизации дефлегматора, устанавливается програмно или в ручную
int temperatyra_deflegmatora_stab_golov = 300; //температура стабилизации дефлегматора при отборе голов 30С
int temperatyra_deflegmatora_stab_hvostov = 400; //температура стабилизации дефлегматора при отборе хвостов 40С
//int temperatyra_deflegmatora_stab_telo = 330; //температура стабилизации дефлегматора при отборе теля 400С
//int temperatyra_deflegmatora_stab_hvostov = 300; //температура стабилизации дефлегматора при отборе хвостов 30С

int temperatyra_na_sebia_start = 740; //температура куба при которой контроллер переходит с нагрева на работу на себя, 74С запаздыываение датчика где то 4С
int temperatyra_golov_start = 300; //температура дефлегматора при которой контроллер переходит от работы на себя к отбору голов, 30С означает что деф прогрелся
int temperatyra_hvostov_start = 9800; //температура куба при которой контроллер переходит на отбор хвостов, 90С
//int temperatyra_hvostov_konec = 9900; //температура куба при которой контроллер заканчивает отбор хвостов, 96,5С
int temperatyra_rect_konec = 10100; //температура куба при которой контроллер заканчивает ректификацию



// для вычисления времени
//unsigned long tik; // тестовый счетчик секунд который будет возвращать значение из прерывания
unsigned long ten_time_on;  // время включения тэна для медленного шим в 2.55 секудны
unsigned long ten_time_off;  // время выключения тэна для медленного шим
unsigned long time_now;   // переменная для обработки прерывания ШИМА в процедуре ten_shim_set

unsigned long next_state_time; //время в милисекундах когда заканчивается работа одного процесса и запускается следующий
unsigned long time_na_sebia = 900000; //время работы на себя в милисекундах, 15 минут
unsigned long time_golov = 3600000; // время отбора голов в милисекундах, 60 минут
unsigned long time_hvostov = 7200000;  //время отбора хвостов, минут * секунд * милисекунд, 120 минут

//unsigned long time_all;   // переменная для вывода общего времени
unsigned long time_left;   // переменная для вывода оставшегося времени
unsigned long time_stab_up;   // переменная для хранения времени вызова процедуры стабилизации температуры в дефлегматоре в сторону увеличения
unsigned long time_stab_dw;   // переменная для хранения времени вызова процедуры стабилизации температуры в дефлегматоре в сторону уменьшения
unsigned long time_otbor; //// переменная для хранения времени вызова процедуры корректировки скорости отбора
unsigned long time_kuba_nagrev;   // переменная для хранения времени вызова процедуры расчета скорости нагрева

unsigned long time_term;   // переменная для опроса датчиков температуры раз в секунду


byte skorost_otbora; //скорость вентилятора отбора, меняется програмно и в ручную
byte skorost_otbora_nagrev = 0; //скорость вентилятора отбора при нагреве
byte skorost_otbora_nasebia = 110; //скорость вентилятора отбора при работе на себя
byte skorost_otbora_golov = 90; //предварительная скорость вентилятора отбора при отборе голов
byte skorost_otbora_tela = 90; //предварительная скорость вентилятора отбра при отборе тела
byte skorost_otbora_hvostov = 90; //предварительная скорость вентилятора для отбора хвостов
byte skorost_otbora_delta = 90; //базовая скорость вентилятора для для пропорционального регулированиячто бы устранить дребезг на экране, равна телу, можно заменить
byte skorost_otbora_delta_new = 0; //переменная для пропорционального регулирования скорости вентилятора по отклонению температуры, новое расчитаное значение
byte skorost_otbora_delta_old = 0; //переменная для пропорционального регулирования скорости вентилятора по отклонению температуры, старое расчитаное значение

byte ten_nagrev = 120; //мощность ТЭНа при нагреве куба
byte ten_na_sebia = 60; //мощность ТЭНа при работе на себя
byte ten_golov = 60; //мощность ТЭНа при отборе голов
byte ten_tela = 60; //мощность ТЭНа при отборе тела
byte ten_hvostov = 60; //мощность ТЭНа при отборе хвостов

//адреса датчиков температуры
byte Thermometer2[8] = {0x28, 0xAC, 0xC9, 0x67, 0x05, 0x00, 0x00, 0xCD}; //температура куба
//byte Thermometer2[8] = {0x28, 0x87, 0x77, 0x67, 0x05, 0x00, 0x00, 0x6E}; //температура колонны, пока не используется
byte Thermometer1[8] = {0x28, 0x45, 0x61, 0x68, 0x05, 0x00, 0x00, 0xE5}; //температура колонны



volatile byte ten_procent; //значнение мощности от 0 до 255, переменная будет доступна в прерывании

/*
  byte sekynd;      // прошло секунды с начала процесса
  byte minyt;       // прошло минут с начала процесса
  byte chas;        // прошло часов с начала процесса
*/

//переменные для вывода информации на экран
char lcd_text1[16]; //верхняя строчка экрана
char lcd_text2[16]; //нижняя строчка экрана

String lcd_text1_string;
String lcd_text2_string;

// состоянию контроллера
int state = 0; //первое состояние контроллера - все выключить

// подменю контроллера для изменения нескольких значений в одном режиме по выбору кнопкой селект
byte state_pod_menu = 0;

/*
  void NextStateTimer(int time, int next_state) //процедура включает новый режим чеерз определенное колчиство времени
  {
  if (millis()/1000 > time)  {state = next_state;}
  }
*/


void Temperatyra_deflegmatora_set (int temperatyra_deflegmatora_set) //процедура стабилизации температуры дефлегматора для отбора
{
  //пропорциональная составлящаяв плюс
  if (temperatyra_deflegmatora > temperatyra_deflegmatora_set && skorost_otbora < skorost_otbora_delta * 2) // && skorost_otbora < 255 && millis() > time_stab_up) //условия повышения оборотов вентилятора = температура + значение + время
  {
    skorost_otbora_delta_new = (temperatyra_deflegmatora - temperatyra_deflegmatora_set) *  skorost_otbora_delta / 450; //при скорости отбора = 90 будет 1 значений на 0,5С
    skorost_otbora = skorost_otbora + skorost_otbora_delta_new - skorost_otbora_delta_old; //прибавить новое значение отнять старое
    skorost_otbora_delta_old = skorost_otbora_delta_new; //заменить старое значение поправки новым
  }

  //интегральная составляющая плюс
  if (temperatyra_deflegmatora > temperatyra_deflegmatora_set && skorost_otbora < 255 && millis() > time_stab_up )
  {
    time_stab_up = millis() + 60000; //отложить следующее повышение на 1 минуту
    time_stab_dw = 0;                //разрешить сразу понижать обороты вентилятора охлаждения
    skorost_otbora++;                //увеличить обороты вентилтора охлаждения
  }

  //пропорциональная составлящаяв минус
  if (temperatyra_deflegmatora < temperatyra_deflegmatora_set && skorost_otbora > skorost_otbora_delta / 2) // && skorost_otbora < 255 && millis() > time_stab_up) //условия повышения оборотов вентилятора = температура + значение + время
  {
    skorost_otbora_delta_new = (temperatyra_deflegmatora_set - temperatyra_deflegmatora) *  skorost_otbora_delta / 450; //при скорости отбора = 90 будет 1 значений на 0,5С
    skorost_otbora = skorost_otbora - skorost_otbora_delta_new + skorost_otbora_delta_old; //прибавить новое значение отнять старое
    skorost_otbora_delta_old = skorost_otbora_delta_new; //заменить старое значение поправки новым
  }

  //интегральная составляющая минус
  if (temperatyra_deflegmatora < temperatyra_deflegmatora_set && skorost_otbora > 0 && millis() > time_stab_dw) //условия понижения оборотов вентилятора = температура + значение + время
  {
    time_stab_dw = millis() + 60000; //отложить следующее понижение на 1 минуту
    time_stab_up = 0;                //разрешить сразу повышать обороты вентилятора охлаждения
    skorost_otbora--;                //уменьшить обороты вентилтора охлаждения
  }

}

void skorost_otbora_set () //процедура устанавливает температуру дефлегматора для регулирования отбора при измении температуры куба
{
  if (millis() > time_otbor)
  {
    time_otbor = time_otbor + 300000; // время срабатывания процедуры, в милисекунах. 5 минут
    switch (temperatyra_kuba / 200) //сгрубляем диапазон 7800-10000 градусов до 39-50 - шаг два градуса
    {
      case 37: temperatyra_deflegmatora_stab = 390; break; //74-76
      case 38: temperatyra_deflegmatora_stab = 380; break; //76-78
      case 39: temperatyra_deflegmatora_stab = 370; break; //78-80
      case 40: temperatyra_deflegmatora_stab = 360; break; //80-82
      case 41: temperatyra_deflegmatora_stab = 350; break; //82-84
      case 42: temperatyra_deflegmatora_stab = 340; break; //84-86
      case 43: temperatyra_deflegmatora_stab = 330; break; //86-88
      case 44: temperatyra_deflegmatora_stab = 320; break; //88-90
      case 45: temperatyra_deflegmatora_stab = 310; break; //90-92
      case 46: temperatyra_deflegmatora_stab = 300; break; //92-94
      case 47: temperatyra_deflegmatora_stab = 290; break; //94-96
      case 48: temperatyra_deflegmatora_stab = 280; break; //96-98
      case 49: temperatyra_deflegmatora_stab = 270; break; //98-100
      case 50: temperatyra_deflegmatora_stab = 260; break; //100-102
    }
  }
}
/*
  270 - 27С - 9,5 мл/час
  300 - 30С - 54 мл/час
  330 - 33С - 133 мл/час
  360 - 36С - 150 мл/час
  450 - 45С - 200 мл/час

*/



void ChangeState(int state_next) //процедура вносит задержку в нажатие кнопок
{
  state = state_next;
  delay(150);
  Serial.print("ChangeState=");
  Serial.println(state_next);
  lcd.clear();
}



void process_button(int bt_sl, int bt_lf, int bt_rt, int bt_up, int bt_dw) //SEL LF RT UP DW
{
  /*
    Serial.print("button process=");
    Serial.println(button);
    Serial.print("BUTTON_RIGHT=");
    Serial.println(BUTTON_RIGHT);
    Serial.print("BUTTON_LEFT=");
    Serial.println(BUTTON_LEFT);
    Serial.print("BUTTON_UP=");
    Serial.println(BUTTON_UP);
    Serial.print("BUTTON_DOWN=");
    Serial.println(BUTTON_DOWN);
    Serial.print("BUTTON_SELECT=");
    Serial.println(BUTTON_SELECT);
  */

  switch (button)
  {
    case BUTTON_RIGHT:
      ChangeState(bt_rt);
      break;
    case BUTTON_LEFT:
      ChangeState(bt_lf);
      break;
    case BUTTON_UP:
      ChangeState(bt_up);
      break;
    case BUTTON_DOWN:
      ChangeState(bt_dw);
      break;
    case BUTTON_SELECT:
      ChangeState(bt_sl);
      break;
  }
}




//процедура определения нажатой кнопки
int getPressedButton()
{
  int buttonValue = analogRead(0); // считываем значения с аналогового входа(A0)
  //Serial.println(buttonValue);
  if (buttonValue < 100)
  {
    return BUTTON_RIGHT;
  }
  else if (buttonValue < 200)
  {
    return BUTTON_UP;
  }
  else if (buttonValue < 400)
  {
    return BUTTON_DOWN;
  }
  else if (buttonValue < 600)
  {
    return BUTTON_LEFT;
  }
  else if (buttonValue < 800)
  {
    return BUTTON_SELECT;
  }
  return BUTTON_NONE;
}

/*void vremia() //процедура выводит в нижнюю строку ЖК время работы контроллера
  {
  chas = tik/3600;
  minyt = (tik-chas*3600)/60;
  sekynd = tik-(chas*3600)-(minyt*60);
  sprintf(lcd_text,"%02uh%02um%02u",chas,minyt,sekynd); //выравниввает значения по левому краю, добавляет нули и еще что-то
  lcd.setCursor(0, 1);
  lcd.print(lcd_text);
  }
*/

//регулирвоание мощности медленным ШИМом

void ten_shim_set (int ten_procent) //включение и выключение ТЭНа в течении одного такта шим, расчет времени на такт шима
{
  time_now = millis();
  if (time_now > ten_time_on && time_now < ten_time_off)  //шим для ТЭНа, проверяет необходимость включить или выключить ТЭН
  {
    digitalWrite(13, HIGH);
  }
  else
  {
    digitalWrite(13, LOW);
  }
  if (time_now > ten_time_off) //если закончился период шима запускает расчет времени включения и выключения следующего такта шим ТЭНа
  {
    ten_time_on = time_now + 2550 - 10 * ten_procent; //устанавливает время в мс включения ТЭНа исходя из мощности, ступенька регулирования 1/255 = 0,4%  при 255 ТЭН на момент расчета уже должен быть включен
    ten_time_off = time_now + 2550; //устанавилвает время выключения ТЭНа
  }
}


// процедура которая вызывается при переполнении таймера 2, настройка таймера прерывания ниже
ISR (TIMER2_COMPA_vect)
{
  ten_shim_set(ten_procent);
}




void setup() {
  Serial.begin(9600);
  Serial.println("Controller start ...");

  // Start up the library DS18BB20
  //sensors.begin();

  state = 0; //первое состояние контроллера - 0 - все выключено

  pinMode(2, OUTPUT); //вентилятор холодильника, цифровой выход
  pinMode(3, OUTPUT); //клапан отбора хвостов, цифровой выход
  pinMode(10, OUTPUT); //вентилятор дефлегматора, ШИМ
  pinMode(13, OUTPUT); //управление ТЭНом и встроенный светодиод

  /*
    //код переводит датчик в 12 битный режим, срабатывает только с одним датчиком на линии,
    ds.write(0xCC); // Для обращения ко всем 1-Wire устройствам, подключенным к шине, используется команда skip rom. Например, эту команду можно применять, чтобы запустить температурное преобразование сразу всех датчиков DS18B20
    ds.write(0x4E); // записывать в ОЗУ датчика DS18B20 три байта – Th, Tl и конфигурационный регистр (2, 3, 4 байты ОЗУ соответственно).
    ds.write(0x4B); //  то, что прочиталось по адресу data[2] в процессе чтения for ( i = 0; i < 9; i++) { data[i] = ds.read();}
    ds.write(0x46); // то, что показало по адресу data[3] по идее это верхняя и нижняя границы измерений
    ds.write(0x7F); // конфигурационный байт, по дефолту 000111111, становиться 01111111. две первые еденицы отвечают за разрядность ацп
    ds.write(0xCC);  // сбрасывается память
    ds.write(0x48); // Эта команда копирует 2, 3 и 4 байты ОЗУ (Tl, Th и конфигурационный регистр соответственно) в EEPROM датчика.
  */
  Serial.print("LCD...");
  lcd.begin(16, 2); //запуск ЖК экрана
  // lcd.print("PRESS_ANY_KEY   ");        //стартовая надпись на экране

  //найстройка таймера прерываний для вызыва автоматически примерно 100 раз в секунду
  //------ Timer2 ----------
  //TCCR2A = (1<<CS20);  Тактирование от CLK или Если нужен предделитель :
  // TCCR2A = (1<<CS21);                     // CLK/8
  // TCCR2A = (1<<CS20)|(1<<CS21);           // CLK/32
  // TCCR2A = (1<<CS22);                     // CLK/64
  // TCCR2A = (1<<CS20)|(1<<CS22);           // CLK/128
  // TCCR2A = (1<<CS21)|(1<<CS22);           // CLK/256
  TCCR2A = (1 << CS20) | (1 << CS21) | (1 << CS22); // CLK/1024
  TCCR2A = (1 << WGM21);  // Режим CTC (сброс по совпадению)

  OCR2A = 75;            // Верхняя граница счета. Диапазон от 0 до 255.
  // Частота прерываний будет = Fclk/(N*(1+OCR2A))
  // где N - коэф. предделителя (1, 8, 32, 64, 128, 256 или 1024)
  // 155 для 1/100

  TIMSK2 = (1 << OCIE2A); // Разрешить прерывание по совпадению

  sei ();                 // Глобально разрешить прерывания

  // диагностика работоспособности вентиляторов и клапана
  Serial.print("test output...");
  lcd.setCursor(0, 0);
  lcd.print("version 0104");
  lcd.setCursor(0, 1);
  lcd.print("write by dee");
  delay(500); //подождать
  lcd.setCursor(0, 1);
  lcd.print("test cooler     ");
  digitalWrite(2, 1); //включить холодильник
  delay(500); //подождать
  digitalWrite(2, 0); //вылючить холодильник
  lcd.setCursor(0, 1);
  lcd.print("test klapon     ");
  digitalWrite(3, 1); //открыть клапан отбора хвосток
  delay(500); //подождать
  digitalWrite(3, 0); //закрыть клапан отбора хвосток
  delay(500); //подождать
  lcd.setCursor(0, 1);
  lcd.print("test deflegmator");
  analogWrite(10, 64); //включить дефлегматор
  delay(500); //подождать
  analogWrite(10, 127); //выключить дефлегматор
  Serial.println("OK");

  //EEPROM.get(0, temperatyra_rect_konec);
  
}





void loop() {

  // обработка нажатых конопок
  button = getPressedButton();
  //Serial.print("button loop=");
  //Serial.println(button);

  //вывод текста на экран, вывод строки сначала 0,0 а потом 0,1 вызывает глюки
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print(lcd_text2);
  lcd.setCursor(0, 0);
  lcd.print(lcd_text1);

  //Serial.print("button LCD=");
  //Serial.println(button);

  // чтение температуры , можно сделать раз в секунду
  if (millis() >= time_term)  {   // переменная для хранения времени датчиков температуры
    ds.reset(); //сбросить линию
    ds.select(Thermometer1); //обратиться к датчику 1
    ds.write(0xBE); // запустить чтение температуры из датчика
    data[0] = ds.read();
    data[1] = ds.read();
    data[2] = ds.read();
    data[3] = ds.read();
    data[4] = ds.read();
    data[5] = ds.read();
    data[6] = ds.read();
    data[7] = ds.read();
    data[8] = ds.read();
    temperatyra_kuba = data[1];   //два байта складываются в одно число плюс поправка по температуре кипения воды
    temperatyra_kuba *= 256;         //
    temperatyra_kuba += data[0]; //
    temperatyra_kuba *= 100;      //
    temperatyra_kuba /= 16;       //
    temperatyra_kuba -= 11;       // поправка на лед -11
    temperatyra_kuba *= 10456;   // коэффициент на кипящую воду
    temperatyra_kuba /= 10000;   // вернуть обратно, не перескачить лонг 9985 * 100000 = 998 500 000 < 2 147 483 647
    ds.reset(); //сбросить линию
    ds.select(Thermometer1); //обратиться к датчику 1
    ds.write(0x44); // запустить преобразование температуры в датчике

    ds.reset(); //сбросить линию
    ds.select(Thermometer2); //обратиться к датчику 2
    ds.write(0xBE); // запустить чтение температуры из датчика
    data[0] = ds.read();
    data[1] = ds.read();
    data[2] = ds.read();
    data[3] = ds.read();
    data[4] = ds.read();
    data[5] = ds.read();
    data[6] = ds.read();
    data[7] = ds.read();
    data[8] = ds.read();
    temperatyra_deflegmatora = ((data[1] << 8) + data[0]) * 10 / 16; // два байта складываются в одно число
    ds.reset(); //сбросить линию
    ds.select(Thermometer2); //обратиться к датчику 2
    ds.write(0x44); // запустить преобразование температуры в датчике
    time_term += 1000;

    //заодно и экран перерисовать на случай артефакто после замены спринтф на стринг
    lcd.clear();
    lcd.setCursor(0, 1);
    lcd.print(lcd_text2);
    lcd.setCursor(0, 0);
    lcd.print(lcd_text1);
  }


  //temperatyra_kuba = 8765;
  //temperatyra_deflegmatora = 421;

  /*
     if (millis() >= time_term)  {   // переменная для хранения времени датчиков температуры
       temperatyra_kuba = sensors.getTempC( Thermometer1);
       Serial.print("temperatyra_kuba=");
       Serial.print(temperatyra_kuba);
       temperatyra_kuba *= 10;
       Serial.print(", *10=");
       Serial.println(temperatyra_kuba);
       temperatyra_deflegmatora = sensors.getTempC(Thermometer2);
       temperatyra_deflegmatora *= 10;
       //sensors.requestTemperatures();
       time_term += 1000;
     }
  */
  //Serial.print("button temp read=");
  //Serial.println(button);


  //раздел безопасности

  //если отвалился или заглючил датчки перейти к остановке устройства

  /*
    if (temperatyra_kuba > 994) //в кубе вода
    {
      state = 0;
    }

    if (temperatyra_deflegmatora > 700) //перегрев дефлегматора
    {
      state = 0;
    }

    if (temperatyra_kuba < 10) //отвалился датчик температуры куба
    {
      state = 0;
    }


    if (temperatyra_deflegmatora < 10) //отвалился датчик температуры дефлегматора
    {
      state = 0;
    }
  */

  switch (state)  //выбрать режим работы
  {

    case 0000: // режим "все выключено" выход через нажатие SELECT
      ten_procent = 0; //выключить ТЭН
      digitalWrite(2, 0); //выключить холодильник
      digitalWrite(3, 0); //закрыть клапан отбора хвосток
      analogWrite(10, 0); //выключить дефлегматор
      ChangeState(2);
      break;


    case 0001: // ректификация в автоматическом режиме
      process_button(1010, 9, 2, 0, 0); //SEL LF RT UP DW

      sprintf(lcd_text1, "<  auto  rect  >");
      sprintf(lcd_text2, "  SEL to START  ");

      break;


    case 0002: // ректификация в ручном режиме

      process_button(2000, 1, 9, 0, 0); //SEL LF RT UP DW
      //Serial.println("manual rect");

      //Serial.print("button case 0002=");
      //Serial.println(button);

      sprintf(lcd_text1, "< manual  rect >");
      sprintf(lcd_text2, "  SEL to START  ");

      //Serial.print("button sprintf=");
      //Serial.println(button);


      break;


    case 9: // настройки датчика температуры
      process_button(9001, 2, 1, 0, 0); //SEL LF RT UP DW

      sprintf(lcd_text1, "<   SETTING    >");
      sprintf(lcd_text2, "  SEL to START  ");

      break;


    /*
        case 0002: // увеличить мощность

          break;

        case 0003: // уменшить мощность

          break;

        case 0002: // увеличить обдув

          break;

        case 0003: // уменшить уменьшить

          break;
    */

    case 1000: // режим работы - автоматическая ректификация

      ten_procent = 0; //выключить ТЭН

      digitalWrite(2, 0); // выключить холодильник
      analogWrite(10, 0); //установить скорость вентилятора отбора

      sprintf(lcd_text1, "auto rectify");
      sprintf(lcd_text2, "SEL to START");

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(2000);
          break;
        case BUTTON_LEFT:
          ChangeState(3000);
          break;
        case BUTTON_UP:
          break;
        case BUTTON_DOWN:
          break;
        case BUTTON_SELECT:
          ChangeState(1010);
          break;
      }
      break;



    case 1010: // установки при нагреве куба
      digitalWrite(2, 0); // выключить холодильник
      digitalWrite(3, 1); // открыть клапан отбора голов
      skorost_otbora = skorost_otbora_nagrev; //устаносить скорость вентилятора отбора
      analogWrite(10, 0); //установить скорость вентилятора отбора (включить дефлегматор)
      state_pod_menu = 0; //подменю нет
      ten_procent = ten_nagrev;  //включить ТЭН на нагрев

      ChangeState(1011);
      break;

    case 1011: // нагрев до температуры temperatyra_na_sebia_start

      if (temperatyra_kuba > temperatyra_na_sebia_start) //переход к работе на себя по температуре в кубе
      {
        ChangeState(1015);
      }

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора включить дефлегматор

      if (millis() > time_kuba_nagrev) //расчет скорости нагрева
      {
        time_kuba_nagrev = time_kuba_nagrev + 20000; //база времения для замера скорости или один раз в 20 сек расчитывать скорость нагрева
        if (temperatyra_kuba > temperatyra_kuba_pred + 2) //если за 20 сек куб нагрелся более чем на 0,2 градуса время нагрева с 20 до 75 будет менее 91,66 минут
        {
          time_left = ( temperatyra_na_sebia_start - temperatyra_kuba ) / ( 3 * temperatyra_kuba - 3 * temperatyra_kuba_pred); // 60 / базу времени 20 секунд = 3 т.е три раза в минуту
        }
        else
        {
          time_left = 99; //если куб греется менее чем на 0,2 градуса за 20 сек то выводится 99
        }
        temperatyra_kuba_pred = temperatyra_kuba; //запомнить температуру куба для следующего вызова процедуры
      }

      //вывод информации на экран
      sprintf(lcd_text1, "R1%01u W%03u V%03u" , state_pod_menu , ten_procent, skorost_otbora);
      sprintf(lcd_text2, "~%03ub%03u %03uk %02u", temperatyra_kuba, temperatyra_na_sebia_start, temperatyra_deflegmatora, time_left);  // информация о температуре в кубе и колонне

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1015);
          break;
        case BUTTON_LEFT:
          ten_procent = 0; //выключить ТЭН
          ChangeState(1000);
          break;
        case BUTTON_UP:
          temperatyra_na_sebia_start = temperatyra_na_sebia_start + 1; //
          ChangeState(1011);
          break;
        case BUTTON_DOWN:
          temperatyra_na_sebia_start = temperatyra_na_sebia_start - 1;
          ChangeState(1011);
          break;
        case BUTTON_SELECT:

          break;
      }
      break;



    case 1015: // установки при прогреве колонны
      ten_procent = ten_na_sebia; // мощность при работе на себя
      digitalWrite(2, 0); // выключить холодильник !
      digitalWrite(3, 1); // открыть клапан отбора голов
      skorost_otbora = 0; //установить скорость вентилятора отбора
      state_pod_menu = 5; //начальное подменю
      next_state_time = millis(); //запомнить время для расчета прошедшего с начала работы в режиме

      ChangeState(1016);
      break;


    case 1016: // прогрев колонны

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      if (temperatyra_deflegmatora > temperatyra_golov_start) { //переход к работе на себя при температуре в дефе 30с
        ChangeState(1020);
      }

      time_left = (millis() - next_state_time) / 60000; //время работы в режиме прогрева колонны


      sprintf(lcd_text1, "R15%01u W%03u V%03u" , state_pod_menu , ten_procent , skorost_otbora);
      sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_golov_start, time_left);

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1020);
          break;
        case BUTTON_LEFT:
          ChangeState(1010);
          break;
        case BUTTON_UP:
          temperatyra_golov_start++;
          ChangeState(1016);
          break;
        case BUTTON_DOWN:
          temperatyra_golov_start--;
          ChangeState(1016);
          break;
        case BUTTON_SELECT:
          break;
      }

      break;


    case 1020: // установки при работе на себя, режим практически бесполезный
      ten_procent = ten_na_sebia; // мощность при работе на себя
      digitalWrite(2, 1); // включить холодильник
      digitalWrite(3, 1); // открыть клапан отбора голов
      skorost_otbora = skorost_otbora_nasebia; //установить предварительную скорость вентилятора отбора
      state_pod_menu = 0; //начальное подменю
      next_state_time = millis() + time_na_sebia; //запомнить время для расчета прошедшего с начала работы в режиме
      temperatyra_deflegmatora_stab = 300; //что бы убрать нули в меню

      ChangeState(1021);
      break;


    case 1021: // работе на себя

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      if (millis() > next_state_time) {  //переход к следующему режиму через определенное время
        ChangeState(1030);
      }

      time_left = (next_state_time - millis()) / 60000; //время работы в режиме на себя



      switch (state_pod_menu)
      {
        case 0:
          sprintf(lcd_text1, "R2%01u~W%03u V%03u" , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 1:
          sprintf(lcd_text1, "R2%01u W%03u~V%03u  " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 2:
          sprintf(lcd_text1, "R2%01u W%03u V%03u  " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u~k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 3:
          sprintf(lcd_text1, "R2%01u W%03u V%03u  " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u~%02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

      }

      switch (button)
      {
        case BUTTON_RIGHT:
          //      next_state_time = millis() + time_golov;
          ChangeState(1030);
          break;
        case BUTTON_LEFT:
          ChangeState(1010);
          break;
        case BUTTON_UP:
          switch (state_pod_menu) {
            case 0:
              ten_procent++;
              break;
            case 1:
              skorost_otbora++;
              break;
            case 2:
              temperatyra_deflegmatora_stab++;
              break;
            case 3:
              next_state_time = next_state_time + 60000;
              break;
          }
          ChangeState(1021);
          break;
        case BUTTON_DOWN:
          switch (state_pod_menu) {
            case 0:
              ten_procent--;
              break;
            case 1:
              skorost_otbora--;
              break;
            case 2:
              temperatyra_deflegmatora_stab--;
              break;
            case 3:
              next_state_time = next_state_time - 60000;
              break;
          }
          ChangeState(1021);
          break;
        case BUTTON_SELECT:
          state_pod_menu++;
          if (state_pod_menu > 3) {
            state_pod_menu = 0;
          }
          ChangeState(1021);
          break;
      }
      break;


    case 1030: // установки при отборе голов
      ten_procent = ten_golov; //мощность при отборе голов
      digitalWrite(3, 1); // открыть клапан отбора голов
      digitalWrite(2, 1); // включить холодильник
      skorost_otbora = skorost_otbora_golov; //установить предварительную скорость вентилятора отбора
      temperatyra_deflegmatora_stab = temperatyra_deflegmatora_stab_golov; //установить температуру дефлегмтаора для корректировки скорости отбора
      state_pod_menu = 0;
      next_state_time = millis() + time_golov;

      ChangeState(1031);
      break;


    case 1031: // отбор голов

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      Temperatyra_deflegmatora_set(temperatyra_deflegmatora_stab); // процедура вызывается для корректировки температуры дефлегматора

      if (millis() > next_state_time)
      {
        ChangeState(1040);
      }

      time_left = (next_state_time - millis()) / 60000;

      switch (state_pod_menu)
      {
        case 0:
          sprintf(lcd_text1, "R3%01u~W%03u V%03u" , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 1:
          sprintf(lcd_text1, "R3%01u W%03u~V%03u" , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 2:
          sprintf(lcd_text1, "R3%01u W%03u V%03u" , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u~k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 3:
          sprintf(lcd_text1, "R3%01u W%03u V%03u" , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u~%02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

      }
      switch (button)
      {
        case BUTTON_RIGHT:
          //      next_state_time = millis() + time_golov;
          ChangeState(1040);
          break;
        case BUTTON_LEFT:
          ChangeState(1020);
          break;
        case BUTTON_UP:
          switch (state_pod_menu) {
            case 0:
              ten_procent++;
              break;
            case 1:
              skorost_otbora++;
              break;
            case 2:
              temperatyra_deflegmatora_stab++;
              break;
            case 3:
              next_state_time = next_state_time + 300000;
              break;
          }
          ChangeState(1031);
          break;
        case BUTTON_DOWN:
          switch (state_pod_menu) {
            case 0:
              ten_procent--;
              break;
            case 1:
              skorost_otbora--;
              break;
            case 2:
              temperatyra_deflegmatora_stab--;
              break;
            case 3:
              next_state_time = next_state_time - 300000;
              break;
          }
          ChangeState(1031);
          break;
        case BUTTON_SELECT:
          state_pod_menu++;
          if (state_pod_menu > 3) {
            state_pod_menu = 0;
          }
          ChangeState(1031);
          break;
      }
      break;




    case 1040: // установки при ректификации
      next_state_time = millis(); //для расчета времени работы в режиме ректификации
      ten_procent = ten_tela; //мощность при ректификации
      state_pod_menu = 0 ;
      digitalWrite(2, 1); // включить холодильник
      digitalWrite(3, 0); // закрыть клапан отбора голов
      skorost_otbora = skorost_otbora_tela; //установить предварительную скорость вентилятора отбора
      //         temperatyra_deflegmatora_stab = temperatyra_deflegmatora_stab_telo; //установить температуру дефлегмтаора для корректировки скорости отбора

      ChangeState(1041);
      break;

    case 1041: // ректификация, отбор теля

      skorost_otbora_set (); //процедура корректировки скорости отбора по температуре в кубе

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      Temperatyra_deflegmatora_set(temperatyra_deflegmatora_stab); // процедура вызывается для корректировки температуры дефлегматора

      if (temperatyra_kuba > temperatyra_rect_konec) { //переход к завершению работы по температуре в кубе
        ChangeState(1050);
      }

      time_left = (millis() - next_state_time) / 60000; //расчет времени работы в режмие ректификации

      switch (state_pod_menu)
      {
        case 0:
          sprintf(lcd_text1, "R4%01u~W%03u V%03u   " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 1:
          sprintf(lcd_text1, "R4%01u W%03u~V%03u   " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 2:
          sprintf(lcd_text1, "R4%01u W%03u V%03u   " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u~k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;
      }

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1050);
          break;
        case BUTTON_LEFT:
          ChangeState(1030);
          break;
        case BUTTON_UP:
          switch (state_pod_menu) {
            case 0:
              ten_procent++;
              break;
            case 1:
              skorost_otbora++;
              break;
            case 2:
              temperatyra_deflegmatora_stab++;
              break;
          }
          ChangeState(1041);
          break;

        case BUTTON_DOWN:

          switch (state_pod_menu) {
            case 0:
              ten_procent--;
              break;

            case 1:
              skorost_otbora--;
              break;

            case 2:
              temperatyra_deflegmatora_stab--;
              break;
          }

          ChangeState(1041);
          break;

        case BUTTON_SELECT:
          state_pod_menu++;
          if (state_pod_menu > 2) {
            state_pod_menu = 0;
          }
          ChangeState(1041);
          break;
      }
      break;




    case 1050: // установки при отборе хвостов
      temperatyra_deflegmatora_stab = temperatyra_deflegmatora_stab_hvostov; //скорость отбора хостов
      next_state_time = millis() + time_hvostov; //время отбора хвостов
      ten_procent = ten_hvostov; //мощность при отборе хвостов
      digitalWrite(3, 1); // открыть клапан отбора голов
      digitalWrite(2, 1); // включить холодильник
      //         temperatyra_deflegmatora_stab = temperatyra_deflegmatora_stab_hvostov;
      state_pod_menu = 0;

      ChangeState(1051);
      break;


    case 1051: // отбор хвостов


      if (temperatyra_kuba > temperatyra_hvostov_start) //окончание отбора хвостов по температуре в кубе
      {
        ChangeState(1060);
      }

      if (millis() > next_state_time) //окончание отбора хвостов по времени
      {
        ChangeState(1060);
      }

      Temperatyra_deflegmatora_set(temperatyra_deflegmatora_stab); // процедура вызывается для корректировки температуры дефлегматора

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      time_left = (next_state_time - millis()) / 60000;
      //      time_left = (next_state_time - millis())/1000;

      sprintf(lcd_text1, "R50 W%03u V%03u   " , ten_procent , skorost_otbora);
      //sprintf(lcd_text2,"<LEFT ~t%04u   ", time_left);

      sprintf(lcd_text2, "%03u >", skorost_otbora_hvostov);
      lcd.setCursor(11, 1);
      lcd.print(lcd_text2);

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1060);
          break;
        case BUTTON_LEFT:
          ChangeState(1040);
          break;
        case BUTTON_UP:
          next_state_time = next_state_time + 60000;
          ChangeState(1051);
          break;
        case BUTTON_DOWN:
          next_state_time = next_state_time - 60000;
          ChangeState(1051);
          break;
        case BUTTON_SELECT:
          break;
      }
      break;

    case 1060: // установки при завершении работы, работа на себя
      next_state_time = millis() + 180000; //время работы в режиме - три минуты
      ten_procent = 25; //мощность равная теплопотерям колонны
      digitalWrite(2, 1); // включить холодильник
      digitalWrite(3, 1); // открыть клапан отбора голов
      temperatyra_deflegmatora_stab = 250;
      state_pod_menu = 0;

      ChangeState(1061);
      break;


    case 1061: // завершение работы

      if (millis() > next_state_time) //окончание ректификации по времени
      {
        ChangeState(1090);
      }

      Temperatyra_deflegmatora_set(temperatyra_deflegmatora_stab); // процедура вызывается для корректировки температуры дефлегматора

      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      time_left = (next_state_time - millis()) / 60000;

      switch (state_pod_menu)
      {
        case 0:
          sprintf(lcd_text1, "R6%01u~W%03u V%03u  " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u %02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;

        case 1:
          sprintf(lcd_text1, "R6%01u W%03u V%03u  " , state_pod_menu , ten_procent , skorost_otbora);
          sprintf(lcd_text2, "b%03u k%03u/%03u~%02u", temperatyra_kuba, temperatyra_deflegmatora, temperatyra_deflegmatora_stab, time_left);
          break;
      }

      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1080);
          break;
        case BUTTON_LEFT:
          ChangeState(1050);
          break;
        case BUTTON_UP:
          switch (state_pod_menu)
          {
            case 0:
              ten_procent++;
              break;
            case 1:
              next_state_time = next_state_time + 60000;  ;
              break;
          }
          ChangeState(1061);
          break;
        case BUTTON_DOWN:
          switch (state_pod_menu)
          {
            case 0:
              ten_procent--;
              break;
            case 1:
              next_state_time = next_state_time - 60000;
              break;

          }
          ChangeState(1061);
          break;

        case BUTTON_SELECT:
          state_pod_menu++;
          if (state_pod_menu > 1) {
            state_pod_menu = 0;
          }
          ChangeState(1061);
          break;
      }
      break;
      break;

    case 1090: //окончание ректификации

      ten_procent = 0; //отлючить ТЭН
      digitalWrite(2, 0); // выключить холодильник
      analogWrite(10, 0); // выключить дефлегматор
      digitalWrite(3, 0); // закрыть клапан отбора голов

      sprintf(lcd_text1, "R90 END OF RECT ");
      sprintf(lcd_text2, "<R60        R10>");
      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(1000);
          break;
        case BUTTON_LEFT:
          ChangeState(1080);
          break;
        case BUTTON_UP:
          break;
        case BUTTON_DOWN:
          break;
        case BUTTON_SELECT:
          break;
      }
      break;



    //режим ручной ректификации
    case 2000:
      // установки при ручной ректификации
      next_state_time = millis() + 36000000; //время работы в режиме - 10 часов
      ten_procent = ten_tela; //мощность при ректификации
      state_pod_menu = 0 ;
      digitalWrite(2, 1); // включить холодильник
      digitalWrite(3, 0); // закрыть клапан отбора голов
      skorost_otbora = 60; //установить предварительную скорость вентилятора отбора
      temperatyra_deflegmatora_stab = 300; //установить температуру дефлегмтаора для корректировки скорости отбора
      ChangeState(2010);

      break;

    case 2010: // ректификация в ручном режиме, отбор

      //Serial.println("case 2010:");
      Temperatyra_deflegmatora_set(temperatyra_deflegmatora_stab); // процедура вызывается для корректировки температуры дефлегматора
      analogWrite(10, skorost_otbora); //установить скорость вентилятора отбора

      time_left = (next_state_time - millis()) / 600000;  //расчет времени работы в режмие ректификации

      if (millis() > next_state_time) //окончание ректификации по времени
      {
        ChangeState(2030);
      }

      if (temperatyra_kuba > temperatyra_rect_konec) { //переход к завершению работы по температуре в кубе
        ChangeState(2040);
      }

      // Serial.println("switch (state_pod_menu):");

      switch (state_pod_menu)
      {
        case 0:
          lcd_text1_string = "M" + String(state_pod_menu, DEC) + "~W" + String(ten_procent, DEC) + " V" + String(skorost_otbora, DEC) + " " + String(time_left, DEC);
          lcd_text1_string.toCharArray(lcd_text1, 16);
          lcd_text2_string = "b" + String(temperatyra_kuba, DEC) + " " + String(temperatyra_deflegmatora, DEC) + "/" + String(temperatyra_deflegmatora_stab, DEC);
          lcd_text2_string.toCharArray(lcd_text2, 16);
          break;

        case 1:
          lcd_text1_string = "M" + String(state_pod_menu, DEC) + " W" + String(ten_procent, DEC) + "~V" + String(skorost_otbora, DEC) + " " + String(time_left, DEC);
          lcd_text1_string.toCharArray(lcd_text1, 16);
          lcd_text2_string = "b" + String(temperatyra_kuba, DEC) + " " + String(temperatyra_deflegmatora, DEC) + "/" + String(temperatyra_deflegmatora_stab, DEC);
          lcd_text2_string.toCharArray(lcd_text2, 16);
          break;

        case 2:
          lcd_text1_string = "M" + String(state_pod_menu, DEC) + " W" + String(ten_procent, DEC) + " V" + String(skorost_otbora, DEC) + "~" + String(time_left, DEC);
          lcd_text1_string.toCharArray(lcd_text1, 16);
          lcd_text2_string = "b" + String(temperatyra_kuba, DEC) + " " + String(temperatyra_deflegmatora, DEC) + "/" + String(temperatyra_deflegmatora_stab, DEC);
          lcd_text2_string.toCharArray(lcd_text2, 16);
          break;

        case 3:
          lcd_text1_string = "M" + String(state_pod_menu, DEC) + " W" + String(ten_procent, DEC) + " V" + String(skorost_otbora, DEC) + " " + String(time_left, DEC);
          lcd_text1_string.toCharArray(lcd_text1, 16);
          lcd_text2_string = "b" + String(temperatyra_kuba, DEC) + "~" + String(temperatyra_deflegmatora, DEC) + "/" + String(temperatyra_deflegmatora_stab, DEC);
          lcd_text2_string.toCharArray(lcd_text2, 16);
          break;

      }
      //Serial.println("switch (button):");
      switch (button)
      {
        case BUTTON_RIGHT:
          //ChangeState(0);
          break;
        case BUTTON_LEFT:
          //ChangeState(0);
          break;
        case BUTTON_UP:
          switch (state_pod_menu) {
            case 0:
              ten_procent++;
              break;
            case 1:
              skorost_otbora++;
              break;
            case 2:
              next_state_time = next_state_time + 600000;
              break;
            case 3:
              temperatyra_deflegmatora_stab += 5;
              Serial.print("temperatyra_deflegmatora_stab++ =");   Serial.println(temperatyra_deflegmatora_stab);
              break;
          }
          ChangeState(2010);
          break;
        case BUTTON_DOWN:
          switch (state_pod_menu) {
            case 0:
              ten_procent--;
              break;
            case 1:
              skorost_otbora--;
              break;
            case 2:
              next_state_time = next_state_time - 600000;
              break;
            case 3:
              temperatyra_deflegmatora_stab -= 5;
              Serial.print("temperatyra_deflegmatora_stab-- ="); Serial.println(temperatyra_deflegmatora_stab);
              break;
          }
          ChangeState(2010);
          break;
        case BUTTON_SELECT:
          state_pod_menu++;
          if (state_pod_menu > 3) {
            state_pod_menu = 0;
          }
          ChangeState(2010);
          break;
      }
      break;

    case 2020: //окончание ручной ректификации вручную

      sprintf(lcd_text1, " END OF RECT ?  ");
      sprintf(lcd_text2, "SEL-OK, other-NO");
      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(2010);
          break;
        case BUTTON_LEFT:
          ChangeState(2010);
          break;
        case BUTTON_UP:
          ChangeState(2010);
          break;
        case BUTTON_DOWN:
          ChangeState(2010);
          break;
        case BUTTON_SELECT:
          ChangeState(0);
          break;
      }
      break;

    case 2030: //окончание ручной ректификации по времени

      ten_procent = 0; //выключить ТЭН
      digitalWrite(2, 0); //выключить холодильник
      digitalWrite(3, 0); //закрыть клапан отбора хвосток
      Temperatyra_deflegmatora_set(300); // процедура вызывается для корректировки температуры дефлегматора

      sprintf(lcd_text1, "end time m.rect");
      sprintf(lcd_text2, " press any key  ");
      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(0);
          break;
        case BUTTON_LEFT:
          ChangeState(0);
          break;
        case BUTTON_UP:
          ChangeState(0);
          break;
        case BUTTON_DOWN:
          ChangeState(0);
          break;
        case BUTTON_SELECT:
          ChangeState(0);
          break;
      }
      break;

    case 2040: //окончание ручной ректификации по температуре в кубе

      ten_procent = 0; //выключить ТЭН
      digitalWrite(2, 0); //выключить холодильник
      digitalWrite(3, 0); //закрыть клапан отбора хвосток
      Temperatyra_deflegmatora_set(300); // процедура вызывается для корректировки температуры дефлегматора

      sprintf(lcd_text1, "end temp m.rect");
      sprintf(lcd_text2, " press any key  ");
      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(0);
          break;
        case BUTTON_LEFT:
          ChangeState(0);
          break;
        case BUTTON_UP:
          ChangeState(0);
          break;
        case BUTTON_DOWN:
          ChangeState(0);
          break;
        case BUTTON_SELECT:
          ChangeState(0);
          break;
      }
      break;



    case 9001: //перевести датчик в 12битный режим работы при нажатии SELECT
      sprintf(lcd_text1, "<ds18b20 in 12b>");
      sprintf(lcd_text2, "  SEL to START  ");
      switch (button)
      {
        case BUTTON_RIGHT:
          ChangeState(9002);
          break;
        case BUTTON_LEFT:
          ChangeState(9090);
          break;
        case BUTTON_UP:
          
          //код переводит датчик в 12 битный режим, срабатывает только с одним датчиком на линии,
          //     ds.write(0xCC); // Для обращения ко всем 1-Wire устройствам, подключенным к шине, используется команда skip rom. Например, эту команду можно применять, чтобы запустить температурное преобразование сразу всех датчиков DS18B20

          ds.reset(); //сбросить линию
          ds.select(Thermometer1); //обратиться к датчику 1
          ds.write(0x4E); // записывать в ОЗУ датчика DS18B20 три байта – Th, Tl и конфигурационный регистр (2, 3, 4 байты ОЗУ соответственно).
          ds.write(0x4B); //  то, что прочиталось по адресу data[2] в процессе чтения for ( i = 0; i < 9; i++) { data[i] = ds.read();}
          ds.write(0x46); // то, что показало по адресу data[3] по идее это верхняя и нижняя границы измерений
          ds.write(0x7F); // конфигурационный байт, по дефолту 000111111, становиться 01111111. две первые еденицы отвечают за разрядность ацп
          ds.write(0xCC);  // сбрасывается память
          ds.write(0x48); // Эта команда копирует 2, 3 и 4 байты ОЗУ (Tl, Th и конфигурационный регистр соответственно) в EEPROM датчика.

          ds.reset(); //сбросить линию
          ds.select(Thermometer2); //обратиться к датчику 2
          ds.write(0x4E); // записывать в ОЗУ датчика DS18B20 три байта – Th, Tl и конфигурационный регистр (2, 3, 4 байты ОЗУ соответственно).
          ds.write(0x4B); //  то, что прочиталось по адресу data[2] в процессе чтения for ( i = 0; i < 9; i++) { data[i] = ds.read();}
          ds.write(0x46); // то, что показало по адресу data[3] по идее это верхняя и нижняя границы измерений
          ds.write(0x7F); // конфигурационный байт, по дефолту 000111111, становиться 01111111. две первые еденицы отвечают за разрядность ацп
          ds.write(0xCC);  // сбрасывается память
          ds.write(0x48); // Эта команда копирует 2, 3 и 4 байты ОЗУ (Tl, Th и конфигурационный регистр соответственно) в EEPROM датчика.

          lcd.setCursor(0, 1);
          lcd.print("       OK       ");

          delay(2000);
          ChangeState(9001);
          
          break;
        case BUTTON_DOWN:
          ChangeState(9001);
          break;
        case BUTTON_SELECT:
          ChangeState(9001);
          break;
      }

    case 9002: // автоматическая ректификация, уставка кубовой температуры для окончания процесса
      process_button(9003, 9001, 9090, 9004, 9005); //SEL LF RT UP DW
      sprintf(lcd_text1, "<R Kub Temp End>");
      sprintf(lcd_text2, "%05i", temperatyra_rect_konec);
      break;
   
    case 9003: // автоматическая ректификация, уставка кубовой температуры для окончания процесса, сохранить занчение в памяти
      EEPROM.put(0, temperatyra_rect_konec); //сохранить  в памяти температуру стабилизации точки отбора промежуточных примесей
      sprintf(lcd_text1, "<R Kub Temp End>");
      sprintf(lcd_text2, "%05i is save", temperatyra_rect_konec);
      delay(2000);
      ChangeState(9002);
      break;

    case 9004: // автоматическая ректификация, уставка кубовой температуры для окончания процесса, увеличить температуру на один
      temperatyra_rect_konec++;
      ChangeState(9002);
      break;
    
    case 9005: // автоматическая ректификация, уставка кубовой температуры для окончания процесса, уменьшить температуру на один
      temperatyra_rect_konec--;
      ChangeState(9002);
      break; 

    case 9090: // выход из режима настроек
      process_button(2, 9002, 9003, 2, 2); //SEL LF RT UP DW
      sprintf(lcd_text1, "< Exit Setting >");
      sprintf(lcd_text2, " Press SEL/UP/DW " );
      break;



  } //окончание   switch (state)



} // окончание void loop
